Subject: [PATCH v3 3/9] DocBook/v4l: Add compressed video formats used on MT8173 codec driver

From: [email-masked] (Nicolas Dufresne)
Date: Tue, 12 Jul 2016 15:14:02 -0400

Le mardi 12 juillet 2016 ? 15:08 -0400, Nicolas Dufresne a ?crit?:
> Le mardi 12 juillet 2016 ? 16:16 +0800, Wu-Cheng Li (???) a ?crit?:
> > Decoder hardware produces MT21 (compressed). Image processor can
> > convert it to a format that can be input of display driver.
> > Tiffany.
> > When do you plan to upstream image processor (mtk-mdp)?
> > > 
> > > It can be as input format for encoder, MDP and display drivers in
> > our
> > > platform.
> > I remember display driver can only accept uncompressed MT21. Right?
> > Basically V4L2_PIX_FMT_MT21 is compressed and is like an opaque
> > format. It's not usable until it's decompressed and converted by
> > image
> > processor.
> 
> Previously it was described as MediaTek block mode, and now as a
> MediaTek compressed format. It makes me think you have no idea what
> this pixel format really is. Is that right ?
> 
> The main reason why I keep asking, is that we often find similarities
> between what vendor like to call their proprietary formats. Doing the
> proper research helps not creating a mess like in Android where you
> have a lot of formats that all point to the same format. I believe
> there was the same concern when Samsung wanted to introduce their Z-
> flip-Z NV12 tile format. In the end they simply provided sufficient
> documentation so we could document it and implement software
> converters
> for test and validation purpose.

Here's the kind of information we want in the documentation.

https://chromium.googlesource.com/chromium/src/media/+/master/base/vide
o_types.h#40

? // MediaTek proprietary format. MT21 is similar to NV21 except the memory
? // layout and pixel layout (swizzles). 12bpp with Y plane followed by a 2x2
? // interleaved VU plane. Each image contains two buffers -- Y plane and VU
? // plane. Two planes can be non-contiguous in memory. The starting addresses
? // of Y plane and VU plane are 4KB alignment.
? // Suppose image dimension is (width, height). For both Y plane and VU plane:
? // Row pitch = ((width+15)/16) * 16.
? // Plane size = Row pitch * (((height+31)/32)*32)

Now obviously this is incomplete, as the swizzling need to be documented of course.

> regards,
> Nicolas